/**
 * jQuery Unveil
 * A very lightweight jQuery plugin to lazy load images
 * http://luis-almeida.github.com/unveil
 *
 * Licensed under the MIT license.
 * Copyright 2013 Luís Almeida
 * https://github.com/luis-almeida
 */


(function($) {

	$.fn.unveil = function(threshold, callback, elem) {
		
		var $w = elem ? $(elem) : $(window);
		var th = threshold || 0;
		var retina = window.devicePixelRatio > 1;
		var attrib = retina ? "data-src-retina" : "data-src";
		var images = this;
		var loaded;

		this.one("unveil", function() {
			var source = this.getAttribute(attrib);
			source = source || this.getAttribute("data-src");
			if (source) {
				this.setAttribute("src", source);
				if ( typeof callback === "function")
					callback.call(this);
			}
		});

		function unveil() {			
			var woffset = ($w.offset() ? $w.offset().top : 0) - $(document).scrollTop();
			var inview = images.filter(function() {
				var $e = $(this);
				if ($e.data('pauseUnveil')) return;
				if ($e.css('display') == 'none') {//is(":hidden"))
					return;
				}

				var wt = woffset + $w.scrollTop(); 
				var wb = wt + $w.height();
				var et = $e.offset().top - $(document).scrollTop();
				var eb = et + $e.height();

				return eb >= wt - th && et <= wb + th;
			});

			loaded = inview.trigger("unveil");
			images = images.not(loaded);
		}


		$w.on("scroll.unveil resize.unveil lookup.unveil", unveil);

		unveil();

		return this;

	};

})(window.jQuery || window.Zepto); 

